// * This code is licensed under:
// * JSlovo License, Version 1.0
// * - for license details see http://jslovo.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by the S.Chekanov (chekanov@sdf.lonestar.org). 
// * All rights reserved.

package jslovo.jdatabase;

import java.io.*;
import java.util.*;
import java.lang.*;
import java.util.zip.*;
import java.util.jar.*;
import java.lang.String.*;

// get word from zipped file
public class  dbslovoSearch
{

        private static int MAX_BUFFER = 4096;
        private static  String newline="\n";
        private static byte[] buf = new byte[MAX_BUFFER]; 
        private static long [] indexes;
        private static String inputFile="";
        private static String indexFile="";
        private static String zipFile="";   
        private static String infoFile=""; 
        private static String dataFile="";
        private static String databaseFile="";
        private static int len = 0;  
        private static JarFile zf=null;
        private static JarEntry entry=null;
        private static InputStream in=null;
        private static String topIndexFile="";
        private static String dbdir="";
        private static String SearchWord="";
        public  static ArrayList CandidWord;
        public static HashMap TopHm; // association for top index
        private static String StartLetter=""; 
        private static char   StartChar;
        private static String SecondLetter="";
        private static char   SecondChar;
        public  static String dirpath="";

// set database
// input: database name and absolute path
  public static void SetDB(String dicname, String dirfullpath){

   dbdir=dicname;
   inputFile=dicname+".dic";
   infoFile= dicname+"/"+dicname+".info";
   topIndexFile=dicname+"/"+dicname+".idxtop";
   zipFile=  dirfullpath+File.separator+dicname+".jdic";
   dirpath=dirfullpath;

//   System.out.println("Debug SetDB:"+dicname+ " dirpath="+dirpath);
//   System.out.println("Debug zipFile:"+zipFile);
 
  
  }


// find exact word
  public static String FindExact(String word)throws Exception{

//    StopWatch sw    = new StopWatch();
    SearchWord=word;
    String tmp=""; 
    String stopIndx="";
    long rindx=-1;

// find top index
//    sw.start();
    try { stopIndx=FindTopIndex(); 
    } catch (Exception e) { // System.out.println("Cannot find top index"); 
                           };
//     sw.stop();
//     System.out.println("TOP INDEX access time="+Long.toString(sw.getTime())+ " ms");

// find real index
//   sw.start();
   if (stopIndx.length()>0) {
         try { rindx=FindRealIndex( stopIndx );
         } catch (Exception e) { 
                      //  System.out.println("Cannot find real index"); 
                       };
    } else { 
    //   System.out.println("no top index!");    
       return tmp; } 
//   sw.stop();
//   System.out.println("REAL INDEX access time="+Long.toString(sw.getTime())+ " ms");

// find word
//   sw.start();
   if (rindx>0) {
         try { tmp=FindWord(rindx );
         } catch (Exception e) { System.out.println("Cannot find word"); };
   } else {
     //  System.out.println("no real index!");
       return tmp; }
//   sw.stop();
//   System.out.println("FOUND word time="+Long.toString(sw.getTime())+ " ms");

 return tmp;

 }





// find exact word from index
// necessary when word is not exact  
  public static String FindFromIndex(String word, String cdic, String TopS, long RealIndex){

  SearchWord=word;
  zipFile=  dirpath+File.separator+cdic+".jdic";
  databaseFile=TopS;

  String tmp="";

/*
   System.out.println("Debug: Name of DIC:<"+cdic+">");
   System.out.println("Debug: FindFromIndex word:<"+word+">");
   System.out.println("Debug: FindFromIndex TopINDEX:<"+TopS+">");
   System.out.println("Debug: FindFromIndex RealINDEX:<"+RealIndex+">");
*/
 
   try { tmp=FindWord(RealIndex );
        } catch (Exception e) { 
            System.out.println("FindFromIndex: Cannot find word: "
           +SearchWord); 
          };
   return tmp;

  }




// find not exact word
  public static void FindNotExact(String word)throws Exception{

    SearchWord=word;
    String tmp="";
    String stopIndx="";
    long rindx=-1;


// find top index
    try { stopIndx=FindTopIndex();
    } catch (Exception e) { };


    CandidWord = new ArrayList();


// find real index (arrow)  
   if (stopIndx.length()>0) {
         try {  FindAllRealIndex( stopIndx );
         } catch (Exception e) { };
    } else {
     //   System.out.println("no top index!");
       }
                           
  }


// find top index file 
  public static String FindTopIndex()throws Exception{

  TopHm= new HashMap();

  String sout=""; 
  String stop="";
  StartLetter=SearchWord.substring(0,1);
  StartChar=SearchWord.charAt(0);

 // deallin with non-letters
  if ( !Character.isLetterOrDigit(StartChar) ) StartLetter="$";


 
// find index for this word
  try {

      zf = new JarFile(zipFile);
      entry = zf.getJarEntry(topIndexFile);
      in = zf.getInputStream(entry);

// read index
// read index
    int len=-1;
    byte[] buf1 = new byte[MAX_BUFFER];
    StringBuffer sbuf = new StringBuffer();
    while(
           (len=in.read(buf1,0,MAX_BUFFER))>0 ) {
            String sstmp = new String(buf1, 0, len, "UTF-8");
            sbuf.append(sstmp);
     }



//     System.out.println( sbuf );

      StringTokenizer stt = new StringTokenizer(sbuf.toString(), newline);


              //  System.out.println(ncount);
                while (stt.hasMoreTokens()) {
                  //String ss=st.nextToken();
                   String ss = new String (stt.nextToken() );
     //              System.out.println( ss );

                   int sep2=ss.length();
                   int sep1=ss.indexOf("|");


                 if (sep2>2 && sep1>1) {
                   String sD1 =ss.substring(0,1);
                   String sD2 =ss.substring(sep1+1, sep2);
                    // System.out.println( sD1+ " " + sD2);

                   try {
                   int nn=Integer.parseInt( sD2.trim() );
                   TopHm.put(new String(sD1), new Integer(nn)  );         
                //   System.out.println(  nn );  
                   }
                   catch (NumberFormatException e) {
                   System.out.println( "Error in reading top index" );
                   }
                 }
                 

               }

      in.close();

      } catch (IOException e) {System.out.println("Error in public static String FindTopIndex"); } 

      int kk=-1;

      try {
        kk = ( (Integer)TopHm.get( StartLetter ) ).intValue();
       } catch (Exception e) { } 


     //  System.out.println( kk ); 
      stop=Integer.toString(kk);

//   System.out.println( "Debug: top index: "+stop );

   return stop;

  }





// Step 2: From Top index find real index
   public static long FindRealIndex( String stop ){

    String sout="";
    int beginIndex=-1;
    int endIndex=-1;
    String searchS=newline+SearchWord+" |";
    int lengthS=searchS.length();
    long ifound=-1;
    
// get correct index file 
      if (SearchWord.length()>1) {
      SecondLetter=SearchWord.substring(1,2);
      SecondChar=SearchWord.charAt(1);
 // deallin with non-letters
      if ( !Character.isLetterOrDigit(SecondChar) ) SecondLetter="$";

      int kk=-1;
      kk = ( (Integer)TopHm.get( SecondLetter ) ).intValue();
     //  System.out.println( kk arAt
      String stmp=Integer.toString(kk);

      databaseFile=dbdir+"/f"+stop+"/s"+stmp;
      indexFile=databaseFile+".idx";
      
      } else {
         // with one symbol  
        databaseFile=dbdir+"/f00";
        indexFile=databaseFile+".idx";
       } 

        

//       System.out.println("Debug: Index file is: "+indexFile);

   try {
       zf = new JarFile(zipFile);
       entry = zf.getJarEntry(indexFile);
       in = zf.getInputStream(entry);

// read index
      while(ifound == -1 &&
           (len=in.read(buf,0,MAX_BUFFER)) != -1) { 

      sout = new String(buf, 0, len);
      beginIndex=sout.indexOf( searchS );

      if (beginIndex >-1 ) {
                      //    System.out.println("Found Real index: "+beginIndex);
                      //    System.out.println(sout);
                         endIndex=sout.indexOf(newline, beginIndex+lengthS );
                         sout=sout.substring(beginIndex+lengthS, endIndex);
                              if (sout.trim().length()>0) {
                              try {
                              ifound=Long.parseLong( sout.trim() );
                              } catch (NumberFormatException nfe) {
                                     nfe.printStackTrace();
                              }
                              // System.out.println("Found Real index: "+ifound);
                         }
                      }
      }
      in.close();

 } catch (IOException e) { System.out.println("NO Real index file"); }

  return ifound;

 }




// find all candidates : 
   public static void FindAllRealIndex( String stop )throws Exception{

    String sout="";
    int beginIndex=-1;
    int endIndex=-1;
    String searchS=SearchWord;
    int lengthS=searchS.length();
    long ifound=-1; 

 //   System.out.println("Debug: FindAllRealIndex from "+stop);

// get correct index file
      if (SearchWord.length()>1) {
      SecondLetter=SearchWord.substring(1,2);
      SecondChar=SearchWord.charAt(1);
 // deallin with non-letters
      if ( !Character.isLetterOrDigit(SecondChar) ) SecondLetter="$";

      int kk=-1;
      kk = ( (Integer)TopHm.get( SecondLetter ) ).intValue();
     //  System.out.println( kk );
      String stmp=Integer.toString(kk);

      databaseFile=dbdir+"/f"+stop+"/s"+stmp;
      indexFile=databaseFile+".idx";

      } else {
         // with one symbol
        databaseFile=dbdir+"/f00";
        indexFile=databaseFile+".idx";
       }

 //    System.out.println("Debug: FindAllRealIndex: "+indexFile);

 
   try {
       zf = new JarFile(zipFile);
       entry = zf.getJarEntry(indexFile);
       in = zf.getInputStream(entry);

// read index
    int len=-1;
    String sstmp;
    byte[] buf1 = new byte[MAX_BUFFER];
    StringBuffer sbuf = new StringBuffer();
    while(
           (len=in.read(buf1,0,MAX_BUFFER))>0 ) {
            sstmp = new String(buf1, 0, len, "UTF-8");
            sbuf.append(sstmp);
     }

//   System.out.println("Debug: "+sout);
 
      StringTokenizer st = new StringTokenizer(sbuf.toString(), newline);
      int ncount=st.countTokens(); // number of words
      int m=0;
      String[] sword; sword = new String[ncount];
              //  System.out.println(ncount);

                while (st.hasMoreTokens()) { // make sure there is stuff to get
                sword[m]  = st.nextToken();
             //   System.out.println(sword[m]);
                int Slength=sword[m].length();
                int separation=sword[m].indexOf("|");
                String word=sword[m].substring(0,separation-1);
                String windex=sword[m].substring(separation+1,Slength); 
                String stmp=sword[m].substring(0,lengthS);  
              // System.out.println(stmp);
                m++; 
                  if (stmp.equals(searchS) && 
		     separation>0 && 
          	     separation<Slength) {
                         //   System.out.println(stmp);
                         //   System.out.println("Found Real index: "+beginIndex);
                         //   String description=sout.substring(separation+1,Slength);
            String sinfo=word+" |1| "+windex+" |2| "+dbdir+" |3| "+ databaseFile;
            CandidWord.add(new String(sinfo) );
             try {
                     ifound=Long.parseLong( windex.trim() );
                  } catch (NumberFormatException nfe) {
                      nfe.printStackTrace();
               }
                           // System.out.println("Found Real index: "+ifound);
                  }

            }





      in.close();

 } catch (IOException e) { }

//  return ifound;

 }

 

// find word from real index
     public static String FindWord(long ifound)throws Exception{

        String sout="";
        int beginIndex=-1;
        int endIndex=-1;
        String stmp="";

//     System.out.println("Debug: "+stop);

        try {
         zf = new JarFile(zipFile);      
         entry = zf.getJarEntry(databaseFile);
         in = zf.getInputStream(entry);	
         in.skip( ifound );
        
          sout="";
          int take=1;
          int btot=0;
          while (take > 0 && 
                (len=in.read(buf,0,MAX_BUFFER)) != -1 ) {
            stmp = new String(buf, 0, len, "UTF-8");
            sout = sout+stmp;
            beginIndex=stmp.indexOf( newline );
// only 4000 bytes to get
            if (beginIndex >0 ) {
                            take=0; // stop extraction
                            beginIndex=sout.indexOf("|")+1; 
                            endIndex=sout.indexOf( newline, beginIndex);
                            sout=sout.substring(beginIndex, endIndex);
                     //       System.out.println("definition: "+sout);
             }
             }
        in.close();

    } catch (IOException e) {
      System.out.println("FindWord Error in dataFile: "+dataFile);
    }
 

  return sout;

  }




  public static void CheckFiles() throws Exception  {

     try {
        // Open the ZIP file
        JarFile zf = new JarFile(zipFile);
        // Enumerate each entry
        for (Enumeration entries = zf.entries(); entries.hasMoreElements();) {
            // Get the entry name
             String zipEntryName = ((JarEntry)entries.nextElement()).getName();
         //    System.out.println("file contains: "+zipEntryName);
        }
    } catch (IOException e) {
    }

 }






// get short names
  public static String GetShortname(){

  String sout="";

  try {
         // go to index file first
         zf = new JarFile(zipFile);
         entry = zf.getJarEntry(infoFile);
         in = zf.getInputStream(entry);

       // Transfer bytes from the ZIP file to the output file
        byte[] buf = new byte[1024];
        int len=-1;
        while ((len = in.read(buf)) > 0) {
            sout = sout+ new String(buf, 0, len, "UTF-8");
        }
        // Close the streams
        in.close();


        int beginIndex=sout.indexOf("?jslovo-shortname");
        if (beginIndex>0) {
           sout=sout.substring(beginIndex, sout.length());
        } else {
         sout="name not found"; 
         }


        beginIndex=sout.indexOf("|");
        int endIndex=sout.indexOf( newline );
        if (endIndex>0) {
        sout=sout.substring(beginIndex+1,endIndex);
        } else {
         sout="name not found"; 
         }  

      sout=sout.trim();

    } catch (IOException e) {
        System.out.println("Cannot find zipFile  "+zipFile);      
        return "";
    }

  return sout; 
  }



  public static String GetFullname(){
  String sout="";

  try {

    // go to index file first
         zf = new JarFile(zipFile);
         entry = zf.getJarEntry(infoFile);
         in = zf.getInputStream(entry);


       // Transfer bytes from the ZIP file to the output file
        byte[] buf = new byte[1024];
        int len;
        while ((len = in.read(buf)) > 0) {
            sout = sout+ new String(buf, 0, len, "UTF-8");
        }
        // Close the streams
        in.close();
    } catch (IOException e) {
       System.out.println("Cannot find zipFile  "+zipFile);
    }

 int beginIndex=sout.indexOf("?jslovo-fullname");
 sout=sout.substring(beginIndex, sout.length());

 beginIndex=sout.indexOf("|");
 int endIndex=sout.indexOf( newline );
 sout=sout.substring(beginIndex+1,endIndex);
 sout=sout.trim();

 return sout;
 }


  /**
   * Get detailed info about the dictionary
   * @return array with short name, long name, info, entries
   */

  public static String[] GetInfo(){


  	String[] tmp = new String[4];
  	String shortname="not-found";
  	String longname="not-found";
  	String infoname="not-found";
  	String nrwords="0";
  	
  	String sout="";
  	int beginIndex=-1;
  	
  try {
        // go to index file first
        zf = new JarFile(zipFile);
        entry = zf.getJarEntry(infoFile);
        in = zf.getInputStream(entry);

      // Transfer bytes from the ZIP file to the output file
       byte[] buf = new byte[1024];
       int len=-1;
       while ((len = in.read(buf)) > 0) {
           sout = sout+ new String(buf, 0, len, "UTF-8");
       }
       // Close the streams
       in.close();

       int end=sout.indexOf( newline );
       if (end>0) {
         String tt=sout.substring(0, end);
         nrwords=tt.trim();
       }
       
         
       // find short name
       beginIndex=sout.indexOf("?jslovo-shortname");
       if (beginIndex>-1) {  	 
      	   String ssout=sout.substring(beginIndex, sout.length());
      	   beginIndex=ssout.indexOf("|");
      	   int endIndex=ssout.indexOf( newline );
      	   if (endIndex>-1) {
      		     String tt=ssout.substring(beginIndex+1,endIndex);
      		     shortname=tt.trim();
      		     }
       }

       // find short name
       beginIndex=sout.indexOf("?jslovo-shortname");
       if (beginIndex>-1) {  	 
      	   String ssout=sout.substring(beginIndex, sout.length());
      	   beginIndex=ssout.indexOf("|");
      	   int endIndex=ssout.indexOf( newline );
      	   if (endIndex>-1) {
      		     String tt=ssout.substring(beginIndex+1,endIndex);
      		     shortname=tt.trim();
      		     }
       }
       
       beginIndex=sout.indexOf("?jslovo-fullname");
       if (beginIndex>-1) {  	 
      	   String ssout=sout.substring(beginIndex, sout.length());
      	   beginIndex=ssout.indexOf("|");
      	   int endIndex=ssout.indexOf( newline );
      	   if (endIndex>-1) {
      		     String tt=ssout.substring(beginIndex+1,endIndex);
      		     longname=tt.trim();
      		     }
       }
       
       beginIndex=sout.indexOf("?jslovo-info");
       if (beginIndex>-1) {  	 
      	   String ssout=sout.substring(beginIndex, sout.length());
      	   beginIndex=ssout.indexOf("|");
      	   int endIndex=ssout.indexOf( newline );
      	   if (endIndex>-1) {
      		     String tt=ssout.substring(beginIndex+1,endIndex);
      		     infoname=tt.trim();
      		     }
       }
       
       
          
          
   } catch (IOException e) {
       System.out.println("Cannot find zipFile  "+zipFile);      
   }

   
     tmp[0]=shortname;
     tmp[1]=longname;
     tmp[2]=infoname;
     tmp[3]=nrwords;
    
     return tmp;
  }




 }



