// * This code is licensed under:
// * JSlovo License, Version 1.0
// * - for license details see http://jslovo.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by the S.Chekanov (chekanov@sdf.lonestar.org). 
// * All rights reserved.

package jslovo.ui;

import java.net.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.swing.text.*;
import javax.swing.text.html.*;

import jslovo.util.*;
import jslovo.vkeyboard.Keyboard;

public class MakeKeyboard

                           extends JFrame {



    /**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	public  MakeKeyboard() {


// store mainframe dimensions
    Dimension dim = Global.mainFrame.getSize();
    int w=dim.width;
    int h=dim.height;
 // Get the system resolution
    Dimension res = Toolkit.getDefaultToolkit().getScreenSize();
   // make sure the dialog is not too big
    Dimension size = new Dimension(Math.min( (int)(w),res.width),
                        Math.min((int)(0.2*h), res.height) );


    Keyboard keyboard = new Keyboard(this, null, null);
    this.getContentPane().add(keyboard);

    setSize(size); 
    this.pack();
    this.setVisible(true);

    this.setSize(size);
    Util.belowWithin( Global.mainFrame, this );

    Global.mainFrame.StartUnicodeTimer();

   }


}
