// * This code is licensed under:
// * JSlovo License, Version 1.0
// * - for license details see http://jslovo.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by the S.Chekanov (chekanov@sdf.lonestar.org). 
// * All rights reserved.

package jslovo.ui;



import jslovo.util.*;

public class jSlovoGui{


    protected static SplashScreen splashScreen;
    private static int countCallsToAdvance = 0;
    private static int splashProgressLength = 5;
    private static long lastSplashAdvanceTime = System.currentTimeMillis();
    private static long splashAdvanceTimeDiff = 0;

/**
 * Initialize for 3rd party integration. Set a new word and directory path 
 */
    public jSlovoGui(String word, String database_dir, String settingFile, boolean isSearch) {
      
    	
// initialisation of Global parameters 
        Global.init(); 
     //   splashScreenAdvance();

// read options
        Options.init();
//        splashScreenAdvance();

        Global.INIFILE = settingFile;

// read options
        Global.face();
//      splashScreenAdvance();

        ResourceLoader.init ( "jslovo/resources/");

        // new settings
        Global.Word=word;
        Global.DBdir= database_dir;
        Global.isEmbeded=true;


// set databases
       Global.DBases();
   //    splashScreenAdvance();


// list with candidates 
        Global.sCand = new sPropose();
//        splashScreenAdvance();

// start apllication
       Global.mainFrame = new Application(); 
//       splashScreenAdvance();

// list with candidates
       Global.sCand = new sPropose();
   //    splashScreenAdvance();


     // start search if asked.
     if (isSearch)
            Global.mainFrame.Search();
        

}


    /*
        public static void splashScreenAdvance() {
        countCallsToAdvance++;
        splashScreen.advance();

        //TODO: improve the progress bars divisions.
        //debugging which calls to advance need more advance calls in their lower objects
        //so far, setLookAndFeel and SDMFrame take the longest
        if ((System.currentTimeMillis() - lastSplashAdvanceTime) > splashAdvanceTimeDiff) {
            //Log.out("Advance Splash progress for # " + countCallsToAdvance + " : time = " + lastSplashAdvanceTime);
            splashAdvanceTimeDiff = System.currentTimeMillis() - lastSplashAdvanceTime;
        }

        lastSplashAdvanceTime = System.currentTimeMillis();
    }


*/


    public void setLook(String look){

         Global.mainFrame.setLook(look);

    }

    public void setVisible(boolean vis){
         Global.mainFrame.setVisible(vis);
    }





}
