// * This code is licensed under:
// * JSlovo License, Version 1.0
// * - for license details see http://jslovo.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by the S.Chekanov (chekanov@sdf.lonestar.org). 
// * All rights reserved.

package jslovo.ui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

import jslovo.util.Util;

public class sPropose extends JDialog {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	public JButton closeButton;
	// private JPanel panel1;
	// private JPanel mainPane;
	public JList list;
	public DefaultListModel variableModel;

	// public sPropose( Frame parent ) {

	public sPropose() {

		super(Global.mainFrame);

		setTitle("List");
		// setModal( true );
		setResizable(true);

		// LocationSize(parent);
		setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);

		JPanel lowerPanel = new JPanel();
		// lowerPanel.setPreferredSize(new Dimension(100, 30));

		closeButton = new JButton();
		closeButton.setText("Exit");

		// actions
		closeButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {

				Global.SelectSubstring = false;
				Global.description = "";
				Global.Cand.clear();
				Global.CandIndex.clear();
				Global.CandDic.clear();
				Global.CandTopIndex.clear();

				Global.mainFrame.SetToExact();
				setInvisible();
			}
		});

		lowerPanel.add(closeButton, null);
		// topPanel.setLayout( new BorderLayout() );

		JScrollPane jCandScroll = new JScrollPane();
		jCandScroll.setPreferredSize(new Dimension(1, 1));
		jCandScroll.setMinimumSize(new java.awt.Dimension(0, 0));

		getContentPane().add(jCandScroll, java.awt.BorderLayout.CENTER);
		getContentPane().add(lowerPanel, java.awt.BorderLayout.SOUTH);

		variableModel = new DefaultListModel();
		list = new JList(variableModel);
		jCandScroll.getViewport().add(list);
		list.setCellRenderer(new HistoCellRenderer());
		list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		list.setSelectedIndex(0);
		list.setVisibleRowCount(50);

		// show article!
		list.addListSelectionListener(new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent event) {
				// if found
				if (!event.getValueIsAdjusting()
						&& list.getSelectedIndex() >= 0) {
					int index = list.getSelectedIndex();

					// System.out.print("Debug=");
					// System.out.println(index);
					Global.mainFrame.ShowArticleFromIndex(index);

				}
			}
		});

		// listen this windows. if it's closed set to exect
		this.addWindowListener(new WindowAdapter() {
			public void windowActivated(WindowEvent e) {
				// System.out.print("Debug=Open");
			}

			public void windowClosing(WindowEvent e) {
				Global.mainFrame.SetToExact();
				// System.out.print("Debug: closed");
			}
		});

	}

	// create about
	public void FillCand() {

	}

	// create about
	public void setInvisible() {
		setVisible(false);
	}

	// create about
	public void setVisible() {

		// store mainframe dimensions
		Dimension dim = Global.mainFrame.getSize();
		int w = dim.width;
		int h = dim.height;
		// Get the system resolution
		Dimension res = Toolkit.getDefaultToolkit().getScreenSize();

		// make sure the dialog is not too big
		Dimension size = new Dimension(Math.min((int) (0.2 * w), res.width),
				Math.min((int) (1.0 * h), res.height));
		this.setSize(size);

		// pack();
		Util.rightWithin(Global.mainFrame, this);

		// Util.centreWithin( Global.mainFrame, this );
		setVisible(true);

	}

}
