// * This code is licensed under:
// * JSlovo License, Version 1.0
// * - for license details see http://jslovo.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by the S.Chekanov (chekanov@sdf.lonestar.org). 
// * All rights reserved.

package jslovo.ui; 


import jslovo.util.*;
import java.util.*;
import java.awt.event.ActionListener;
import java.io.File;

    public class  Global {

    public static String Word=""; // word to search  
    public static String Message="JSlovo active";


    public static Application     mainFrame;
    public static ActionListener  mainActionListener;
    public static  sPropose       sCand;
    public static String    DicInfo;

    public static String INIFILE=""; 

    public static boolean SelectSubstring=false;


    // localisation 
     public static Locale   locale;
     public static String   LANGU="en";

     // location of GUI 
     public static  int  gui_x;
     public static  int  gui_y;
     public static  int  gui_h;
     public static  int  gui_w;
     public static  String OSsys;
   
    // DB path  
    public static String DBdir="dbase"; 

    // total number of databases in this directory   
    public static int Nmax=0;  
// new stuff
    public static ArrayList<String> dbbases;
    public static ArrayList<String> dbbases_alias;
    public static ArrayList<String> dbbases_full_info;
    public static ArrayList<String> dbbases_no_entries;
    public static ArrayList<String> dbbases_notfound;
    public static ArrayList<String> dbbases_info;
                                   

    public static String word=""; 
    public static String descriptionTMP=""; 
    public static String descriptionHTML;
    public static String description="";
    public static String descriptionHELP="";
    public static String wordHELP="";
    public static String allDescription="";
    public static String allDescriptionHELP="";
    public static String currentDic=""; 
    public static String UnicodeChar="";

 
    // when more than one dic is selected
    public static ArrayList<String> Cand;
    public static ArrayList<String> CandIndex;
    public static ArrayList<String> CandDic;
    public static ArrayList<String> CandTopIndex;
    public static ArrayList<String> CandDicAlias; 
    public static boolean ActivateDic[];  // 0 - not set, 1-set 

    public static String ShortDicName=""; 
    public static String FullDicInfo=""; 
    public static String NoDicEntries="";

// HTML styles 
    public static String font_family="Arial";
    public static String font_name="Arial";
    public static String font_size="14"; 
    public static String font_face="plain";
    public static String font_style="normal";
    public static String background_color="#FFFFFC";
    public static String color="#000000";

// to define style   
    public static int Style=2;
  
     public static String defa= "Cross Platform";

     public static String metal= "Metal";
     public static String metalClassName = "javax.swing.plaf.metal.MetalLookAndFeel";

     public static String motif = "Nimbus";
     public static String motifClassName =
            "javax.swing.plaf.nimbus.NimbusLookAndFeel";

     public static String windows = "Windows";
     public static String windowsClassName =
            "javax.swing.plaf.windows.WindowsLookAndFeel";


     public static String LANG_en= "English";
     public static String LANG_ru= "Russian";
     public static String NrWords;
     public static boolean isEmbeded=false;




 

   public static void init()
   {


        // send default local
        LANGU="en";
        locale = new Locale(LANGU); 
        Locale.setDefault(locale);


         String curDir = System.getProperty("user.dir");
         String DirPath = System.getProperty("java.class.path");
         String fSep = System.getProperty("file.separator");
         int inx= DirPath.lastIndexOf(fSep);
// define absolute directory
         if (inx>0)  {
//         DBdir=curDir+fSep+DirPath.substring(0,inx)+fSep+"dbase";
           DBdir=DirPath.substring(0,inx)+fSep+"dbase";
         } else {
         DBdir="dbase";
         }

   String OS = System.getProperty("os.name").toLowerCase();

  if (OS.indexOf("windows") > -1 || OS.indexOf("nt") > -1) {
     OSsys="windows";
     INIFILE="jslovorc.ini";
  }  else {
     // linux/unix/BS-based/mac
     OSsys="unix/linux";
     INIFILE=".jslovorc"; 
    }

    INIFILE = System.getProperty("user.home") + fSep + INIFILE;

// lisen GUI system. Global style 
     mainActionListener = ActionHandler.getMainActionListener();

   } 


   /**
	 * Task: open databases and read dictionary information
	 * 
	 */
	static public void getDictInfo(){
		
	
		long Ntot=0;
	for (int i = 0; i < Global.dbbases.size(); i++) {
		String sdic = (String) Global.dbbases.get(i);
		String[] info= ReadDB.info(sdic);
		String ShortDicName = info[0];
		if (ShortDicName.length() > 2) {
			
			NoDicEntries="0";
			ShortDicName=info[0];
			FullDicInfo=info[1];
			DicInfo=info[2];
			NoDicEntries=info[3];
			
			
			dbbases_alias.add(ShortDicName );
			dbbases_full_info.add( FullDicInfo );
			dbbases_info.add( DicInfo );
			dbbases_no_entries.add(NoDicEntries);
			// jPanel2.jDicSelect.setValueAt(new String( Global.ShortDicName
			
			// Log.e("ASlovo: ", "  Nr of entries "+NoDicEntries );
			// Log.e("ASlovo: ", "  Alias: "+ ShortDicName );
			// Log.e("ASlovo: ", "  Full info: "+ FullDicInfo );
			// Log.e("ASlovo: ", "  Info: "+ DicInfo );
			
		    long Nr=0;
           try
           {
                Nr = Long.parseLong(NoDicEntries.trim());
           }
           catch (NumberFormatException nfe)
           {
             // System.out.println("NumberFormatException: " + nfe.getMessage());
           }
		    Ntot=Ntot+Nr;
		   
		    
		  // Log.i("ASlovo",   "New dictionaries on the disk="+ss  );
	
					
			// ),i,1);
		} else {

			String ss = "not-found";
			Global.dbbases_alias.add(sdic + " " + ss);
			Global.dbbases_full_info.add(ss);
			Global.dbbases_no_entries.add("0");
			// jPanel2.jDicSelect.setValueAt(new String( sdic+" "+ss ),i,1);
		}
		Global.ActivateDic[i] = false;
	}
	
	NrWords=Long.toString( Ntot);
	
	}
	



    // set faces
    public static void face() {

       Global.font_family= Options.getOption( "article.font.family" );
       Global.font_name= Options.getOption( "article.font.name" );
       Global.font_style= Options.getOption( "article.font.style" );
       Global.font_size= Options.getOption( "article.font.size" );
       Global.font_face= Options.getOption( "article.font.face" );

       Global.color=Options.getOption("article.foreg.color");
       Global.background_color=Options.getOption("article.backg.color");

       // GUI
       Style = Options.getIntOption( "gui.lookfeel" );

// get local
       LANGU = Options.getOption( "user.locale" );
       locale = new Locale(LANGU);
       Locale.setDefault(Global.locale);

     }






    // set databases 
    public static void DBases() {


    // location of databases
     dbbases = new ArrayList<String>();
    // names of the database, info, number of entries 
     dbbases_alias = new ArrayList<String>();
     dbbases_full_info = new ArrayList<String>();
     dbbases_no_entries = new ArrayList<String>();
     dbbases_notfound = new ArrayList<String>();
     dbbases_info = new ArrayList<String>();

    File f1= new File(DBdir); 
    int nn=0;

 
    if (f1.isDirectory()) {

     String s[]=f1.list();

     for (int i=0; i<s.length; i++) {
         File f=new File (DBdir+File.separator+ s[i]);

         if (!f.isDirectory() ) {
             if ( s[i].endsWith(".jdic") 
                  && s[i].length()>7) { 
                  String ss=StringUtil.replace(s[i], ".jdic", ""); 
                  dbbases.add(ss); 
        }
       }
      }


    


// total number of databases
//   System.out.println( "Number of dictionaries="+Integer.toString(dbbases.size()) );
     Nmax=dbbases.size(); 

     Cand= new ArrayList<String>();
     CandIndex = new ArrayList<String>();
     CandDic = new ArrayList<String>();
     CandDicAlias = new ArrayList<String>();
     CandTopIndex = new ArrayList<String>();
     ActivateDic =  new boolean[Nmax];
    

    } // end not directory
      } // end void   

    }
