// * This code is licensed under:
// * JSlovo License, Version 1.0
// * - for license details see http://jslovo.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by the S.Chekanov (chekanov@sdf.lonestar.org). 
// * All rights reserved.

package jslovo.ui;

import java.io.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.text.html.*;


public class PanelHelper extends JScrollPane {
    

    /**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	public JTextPane jHelper; 
    private String newline = "\n";
    private StyledDocument doc;
    private Style style;
    private HTMLEditorKit htmlEditor;
 
    public PanelHelper() {  


    jHelper = new JTextPane()
    {
/**
		 * 
		 */
		private static final long serialVersionUID = 1L;

public void paintComponent( Graphics g )
{
Graphics2D g2d = (Graphics2D) g;
g2d.setRenderingHint( RenderingHints.KEY_ANTIALIASING,
RenderingHints.VALUE_ANTIALIAS_ON );
super.paintComponent( g );
}
};

    htmlEditor = new HTMLEditorKit();
    jHelper.setEditorKit(htmlEditor);



    doc = (StyledDocument)jHelper.getDocument();
//    style = doc.addStyle("StyleName", null);
    style = doc.getStyle("text/html");


    // jArticle.setContentType("text/html"); // show as HTML 
    this.getViewport().add(jHelper);
    Font  fon1= new Font("Arial", Font.BOLD, 14);
    jHelper.setEditable( false );
    jHelper.setFont(fon1);
    jHelper.setText("");
    jHelper.setCaretPosition(0);


     } 


public void paintComponent(Graphics g) {
        Graphics2D g2 = (Graphics2D) g;
        g2.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING,
          RenderingHints.VALUE_TEXT_ANTIALIAS_ON);
        g2.setRenderingHint(RenderingHints.KEY_RENDERING,
          RenderingHints.VALUE_RENDER_QUALITY);
        super.paintComponent(g2);
    }


// get answer   
     public void Get() { 

// search 
      Global.descriptionHELP="";
      Global.description="";
      Global.Cand.clear();
      Global.CandDic.clear();
      Global.CandDicAlias.clear();
      Global.CandIndex.clear();
      Global.CandTopIndex.clear();
      Global.dbbases_notfound.clear();


      for (int i=0; i<Global.dbbases.size();  i++) {
       if ( Global.ActivateDic[i] == true)  { // only actve dictionary 
           // get answer 
             ReadDB.query(i, Global.SelectSubstring);
             

// now vectors are ready
            if (Global.SelectSubstring == false) { // exact answer  
            addCombine();
            }

         //  jArticle.append(Global.description);
       } // active dictionary
       } //  for

// show all 
//      jHelper.setText(Global.descriptionHELP);


// show all

      if (Global.descriptionHELP.length()<1) {
          jHelper.setText("Did you select a database?");
      }

      if (Global.SelectSubstring == false && Global.dbbases_notfound.size()>0) {

         String footer="\n<p><hr> <FONT COLOR=\"#FF6633\"> <b>Not found: </b></FONT><br>";
         jHelper.setText(Global.descriptionHELP+footer);

         try {
          for (int i=0; i<Global.dbbases_notfound.size();  i++) {
          String ss=(String)Global.dbbases_notfound.get(i);
          doc.insertString(doc.getLength(),ss+"\n",style);
          }
          }
          catch (Exception ignore) {}
      } else {
     String footer="\n <p> <hr><div style=\"margin-left:20px;text-align:right;\"><FONT COLOR=\"#FFCC33\"><b>JSlovo 1.0</b></FONT></div>";
     jHelper.setText(Global.descriptionHELP+footer);
       }



      jHelper.setCaretPosition( 0 );

 } // end 




// show answer
     public void addCombine() {

      if (Global.descriptionTMP.length()>1) { 
      String s1= "<H2> "
       +"<FONT COLOR=\"#008000\"> "+Global.currentDic+" </FONT> </SPAN>";

      String s2= " <FONT COLOR=\"#000080\"> "+Global.word+" </FONT> </H2> \n"; 
      Global.descriptionHELP=Global.descriptionHELP+s1+s2+Global.descriptionTMP;

      Format.Correct();     // correct output

      Global.allDescriptionHELP=Global.allDescriptionHELP+Global.descriptionHELP;

// if nothing is fond 
      } else {
//      Global.descriptionTMP = "<H3> <FONT COLOR=\"#008000\"> "+Global.currentDic+" </FONT>"+
//               " <FONT COLOR=\"#000080\"> "+Global.word+" not found </FONT> </H3> \n";
//
//       Global.descriptionHELP=Global.descriptionHELP+Global.descriptionTMP;

         Global.dbbases_notfound.add(Global.currentDic);

      }
       // Append to document
     }

  } // end main class
 
 
